=pod

=head1 NAME

EVP_MAC-KMAC, EVP_MAC-KMAC128, EVP_MAC-KMAC256
- The KMAC EVP_MAC implementations

=head1 DESCRIPTION

Support for computing KMAC MACs through the B<EVP_MAC> API.

=head2 Identity

These implementations are identified with one of these names and
properties, to be used with EVP_MAC_fetch():

=over 4

=item "KMAC-128", "default=yes"

=item "KMAC-256", "default=yes"

=back

=head2 Supported parameters

The general description of these parameters can be found in
L<EVP_MAC(3)/PARAMETERS>.

All these parameters can be set with EVP_MAC_CTX_set_params().
Furthermore, the "size" parameter can be retrieved with
EVP_MAC_CTX_get_params(), or with EVP_MAC_size().
The length of the "size" parameter should not exceed that of a B<size_t>.

=over 4

=item "key" (B<OSSL_MAC_PARAM_KEY>) <octet string>

=item "custom" (B<OSSL_MAC_PARAM_CUSTOM>) <octet string>

=item "size" (B<OSSL_MAC_PARAM_SIZE>) <unsigned integer>

=item "xof" (B<OSSL_MAC_PARAM_XOF>) <integer>

=back

The "xof" parameter value is expected to be 1 or 0. Use 1 to enable XOF
mode. If XOF is enabled then the output length that is encoded as part of
the input stream is set to zero.

=head1 SEE ALSO

L<EVP_MAC_CTX_get_params(3)>, L<EVP_MAC_CTX_set_params(3)>,
L<EVP_MAC(3)/PARAMETERS>, L<OSSL_PARAM(3)>

=head1 COPYRIGHT

Copyright 2018-2019 The OpenSSL Project Authors. All Rights Reserved.

Licensed under the Apache License 2.0 (the "License").  You may not use
this file except in compliance with the License.  You can obtain a copy
in the file LICENSE in the source distribution or at
L<https://www.openssl.org/source/license.html>.

=cut
